| #! /bin/sh |
| . "${srcdir=.}/init.sh"; path_prepend_ . ../src |
| |
| # Test of gettext facilities in the Vala language. |
| # Assumes an fr_FR locale is installed. |
| # Assumes the following packages are installed: vala. |
| |
| # Test for presence of valac. |
| (valac --version) >/dev/null 2>/dev/null |
| test $? -le 1 \ |
| || { echo "Skipping test: valac not found"; Exit 77; } |
| |
| # Test whether valac can compile a trivial program. |
| cat <<\EOF > prog.vala |
| int main (string[] args) { |
| return 0; |
| } |
| EOF |
| : ${VALAC=valac} |
| ${VALAC} prog.vala 2>prog.err \ |
| || { if grep "fatal error: 'glib\.h' file not found" < prog.err > /dev/null; then |
| echo "Skipping test: valac installation incomplete" |
| Exit 77 |
| else |
| cat prog.err 1>&2 |
| echo "Skipping test: valac installation does not work" |
| Exit 77 |
| fi |
| } |
| |
| cat <<\EOF > prog.vala |
| int main (string[] args) { |
| Intl.setlocale (LocaleCategory.ALL, ""); |
| Intl.textdomain ("prog"); |
| Intl.bindtextdomain ("prog", "."); |
| stdout.printf ("%s\n", _("'Your command, please?', asked the waiter.")); |
| stdout.printf ("%s\n", _("%s is replaced by %s.").printf ("FF", "EUR")); |
| return 0; |
| } |
| EOF |
| |
| : ${VALAC=valac} |
| ${VALAC} --Xcc=-DGETTEXT_PACKAGE=\"prog\" prog.vala 2>prog.err \ |
| || { cat prog.err 1>&2; Exit 1; } |
| |
| : ${XGETTEXT=xgettext} |
| ${XGETTEXT} -o prog.tmp --omit-header --no-location prog.vala || Exit 1 |
| LC_ALL=C tr -d '\r' < prog.tmp > prog.pot || Exit 1 |
| |
| cat <<EOF > prog.ok |
| msgid "'Your command, please?', asked the waiter." |
| msgstr "" |
| |
| #, c-format |
| msgid "%s is replaced by %s." |
| msgstr "" |
| EOF |
| |
| : ${DIFF=diff} |
| ${DIFF} prog.ok prog.pot || Exit 1 |
| |
| cat <<\EOF > fr.po |
| msgid "" |
| msgstr "Content-Type: text/plain; charset=ISO-8859-1\n" |
| |
| msgid "'Your command, please?', asked the waiter." |
| msgstr "«Votre commande, s'il vous plait», dit le garçon." |
| |
| # Reverse the arguments. |
| #, c-format |
| msgid "%s is replaced by %s." |
| msgstr "%2$s remplace %1$s." |
| EOF |
| |
| : ${MSGMERGE=msgmerge} |
| ${MSGMERGE} -q -o fr.po.tmp fr.po prog.pot || Exit 1 |
| LC_ALL=C tr -d '\r' < fr.po.tmp > fr.po.new || Exit 1 |
| |
| : ${DIFF=diff} |
| ${DIFF} fr.po fr.po.new || Exit 1 |
| |
| test -d fr || mkdir fr |
| test -d fr/LC_MESSAGES || mkdir fr/LC_MESSAGES |
| |
| : ${MSGFMT=msgfmt} |
| ${MSGFMT} -o fr/LC_MESSAGES/prog.mo fr.po |
| |
| : ${DIFF=diff} |
| cat <<\EOF > prog.ok |
| «Votre commande, s'il vous plait», dit le garçon. |
| EUR remplace FF. |
| EOF |
| cat <<\EOF > prog.oku |
| «Votre commande, s'il vous plait», dit le garçon. |
| EUR remplace FF. |
| EOF |
| |
| : ${LOCALE_FR=fr_FR} |
| : ${LOCALE_FR_UTF8=fr_FR.UTF-8} |
| if test $LOCALE_FR != none; then |
| prepare_locale_ fr $LOCALE_FR |
| LANGUAGE= LC_ALL=$LOCALE_FR ./prog > prog.out |
| case $? in |
| 0) ${DIFF} prog.ok prog.out || Exit 1;; |
| 77) LOCALE_FR=none;; |
| *) Exit 1;; |
| esac |
| fi |
| if test $LOCALE_FR_UTF8 != none; then |
| prepare_locale_ fr $LOCALE_FR_UTF8 |
| LANGUAGE= LC_ALL=$LOCALE_FR_UTF8 ./prog > prog.out |
| case $? in |
| 0) ${DIFF} prog.oku prog.out || Exit 1;; |
| 77) LOCALE_FR_UTF8=none;; |
| *) Exit 1;; |
| esac |
| fi |
| if test $LOCALE_FR = none && test $LOCALE_FR_UTF8 = none; then |
| if test -f /usr/bin/localedef; then |
| echo "Skipping test: no french locale is installed" |
| else |
| echo "Skipping test: no french locale is supported" |
| fi |
| Exit 77 |
| fi |
| |
| Exit 0 |